using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
#region algorithmus
        
        public void BildEinlesen()
        {
            OpenFileDialog opf = new OpenFileDialog(); //Ein "OpenFileDialog" wird geffnet und man liest dadurch den Dateinamen des zu vergleichenden Bildes ein
            Bitmap neuesBild = null;                   //Das neue Bild wird definiert;
            if (opf.ShowDialog() == DialogResult.OK)   //berprfung ob die Eingabe im OpenFileDialog Korrekt war
            {
                neuesBild = new Bitmap(Image.FromFile(opf.FileName)); //Dateiname des Bildes wird aus dem OpenFileDialog von vorhin bezogen
                breite = neuesBild.Size.Width;
                hoehe = neuesBild.Size.Height;
                bild = new int[hoehe,breite];
                size = breite * hoehe;

                for (int b = 0; b < breite; b++)
                {
                    for (int h = 0; h < hoehe; h++)
                    {
                        brightness=neuesBild.GetPixel(b, h).GetBrightness();
                        if (brightness < 0.7) bild[h, b] = 1;
                        else bild[h,b]=-1;
                    }
                }
            }
        }
        public void ZeilenSuchen()
        {
            suchzeile = new int[hoehe]; //wenn in zeile mit dazugehriger Hhe (h) ein schwarzes Pixel vorkommt =1 sont =0
            zeilenhoehe = new int[zeilenanzahl, 2]; //erster Wert Anzahl der Zeilen; zweiter Wert fr Anfang/Ende der Zeile
            bool zeilebool=false; //Hilfsvariable ob Textzeile oder keine Zeile
            //Bild nach weien Zeilen durchsuchen und wei oder schwarz Werte der Zeile wird in Array gespeichert
           
            for (int h = 0; h < hoehe; h++)
            {
                for (int b = 0; b < breite; b++)
                {
                  // wenn kein schwarzes pixel -> suchzeile[h]=0 sonst 1; 
                    if (bild[h, b] == 1)
                    {
                        suchzeile[h] = 1;
                        break;
                    }
                    else suchzeile[h] = -1;
                }
                if(suchzeile[h] == 1) //wenn in Zeile mit position (h) schwarze Pixel gefunden
                 { 
                     if (zeilenhoehe[zeilenzaehler,0]!=0) zeilenhoehe[zeilenzaehler,1]++; //berprfung ob Zeilenanfang bereits bekannt wenn ja wird Ende um eins erhht
                     else //sonst wird neue Zeile gschrieben mit anfang=ende =dazugehrige hhe(h)
                         {
                           zeilenhoehe[zeilenzaehler,0]=h;
                           zeilenhoehe[zeilenzaehler,1]=h;
                         }
                    if(zeilebool==false) zeilebool=true; //Wenn Zeilenwechsel von wei auf schwarz wir Variable auf true gesetzt, um zu kontrollieren ob wir in einem schwarzen Zeilenblock sind
                 }
                else if(zeilebool==true) //Wenn Zeile mit der Hhe (h-1) schwarz war und mit der hhe h aber wei wird variable wieder auf "false" gesetzt, weil wir uns nicht mehr im selben Zeilenblock befinden  
                    {
                        zeilebool=false;
                    zeilenzaehler++; //Zhlt die Zeilenblcke
                    if (zeilenanzahl == zeilenzaehler) break;
                    }
             }     
        }
        public void ZeilenAufspalten()
        {
          hoehearray = new int[zeilenanzahl];

          zeileninhalt = new int[zeilenzaehler, 500, breite];
          for (int i = 0; i < zeilenzaehler; i++)
            { 
                for (int q = zeilenhoehe[i, 0]; q <= zeilenhoehe[i, 1]; q++)
                {
                    for (int r = 0; r < breite; r++)
                    {
                        zeileninhalt[i,(q-zeilenhoehe[i, 0]),r]=bild[q, r];
                    }
                }
            }
            #region Zeilenhoehe
            for (int w = 0; w < zeilenanzahl; w++)
            {
                hoehearray[w] = zeilenhoehe[w, 1] - zeilenhoehe[w, 0];
            }
            for (int q = 1; q < zeilenanzahl; q++)
            {
                temp0 = hoehearray[q - 1];
                temp1 = hoehearray[q];
                if (temp1 - temp0 < 0)
                {
                    hoehearray[q] = temp0;
                    hoehearray[q - 1] = temp1;
                }
            }
            neueHoehe = hoehearray[zeilenanzahl - 1];
            #endregion
        }
        
        public void SpaltenSuchen()
        {
            spaltenzaehler = new int[zeilenzaehler];
            suchspalte = new int[breite]; //wenn in zeile mit dazugehriger Hhe (h) ein schwarzes Pixel vorkommt =1 sont =0
            spaltenbreite = new int[zeilenzaehler,11, 2]; //erster Wert Anzahl der Zeilen; zweiter Wert fr Anfang/Ende der Zeile
            bool spaltebool=false; //Hilfsvariable ob Textzeile oder keine Zeile
            //Bild nach weien Zeilen durchsuchen und wei oder schwarz Werte der Zeile wird in Array gespeichert
          
           for (int w=0; w<zeilenzaehler; w++)
           {
               spaltenzaehler[w] = 0;
               for (int b = 0; b < breite; b++)
               {
                   for (int h = 0; h < neueHoehe; h++)
                   {

                       // wenn kein schwarzes pixel -> suchzeile[h]=0 sonst 1; 
                       if (zeileninhalt[w,h,b] == 1)
                       {
                           suchspalte[b] = 1;
                           break;
                       }
                       else suchspalte[b] = -1;
                   }
                   if (suchspalte[b] == 1) //wenn in Zeile mit position (h) schwarze Pixel gefunden
                   {
                       if (spaltenbreite[w, spaltenzaehler[w], 0] != 0) spaltenbreite[w,spaltenzaehler[w], 1]++; //berprfung ob Zeilenanfang bereits bekannt wenn ja wird Ende um eins erhht
                       else //sonst wird neue Zeile gschrieben mit anfang=ende =dazugehrige hhe(h)
                       {
                           spaltenbreite[w,spaltenzaehler[w], 0] = b;
                           spaltenbreite[w,spaltenzaehler[w], 1] = b;
                       }
                       if (spaltebool == false) spaltebool = true; //Wenn Zeilenwechsel von wei auf schwarz wir Variable auf true gesetzt, um zu kontrollieren ob wir in einem schwarzen Zeilenblock sind
                   }
                   else if (spaltebool == true) //Wenn Zeile mit der Hhe (h-1) schwarz war und mit der hhe h aber wei wird variable wieder auf "false" gesetzt, weil wir uns nicht mehr im selben Zeilenblock befinden  
                   {
                       spaltebool = false;
                       spaltenzaehler[w]++; //Zhlt die Zeilenblcke
                       spaltenges++;
                   }
               }
           }    
        }
        public void BreiteundHoehe()
        {
            breitearray = new int[spaltenges];
            
            int spalte = 0;


            for (int w = 0; w < zeilenanzahl; w++)
            {
                for (int a = 0; a < spaltenzaehler[w]; a++)
                {
                    breitearray[spalte] = spaltenbreite[w, a, 1] - spaltenbreite[w, a, 0];
                    spalte++;
                }
            }

            for (int q = 1; q < spaltenges; q++)
            {
                temp0 = breitearray[q - 1];
                temp1 = breitearray[q];
                if (temp1 - temp0 < 0)
                {
                    breitearray[q] = temp0;
                    breitearray[q - 1] = temp1;
                }
            }
            neueBreite = breitearray[spaltenges - 1];

            for (int w = 0; w < zeilenanzahl; w++)
            {
                hoehearray[w] = zeilenhoehe[w, 1] - zeilenhoehe[w, 0];
            }
            for (int q = 1; q < zeilenanzahl; q++)
            {
                temp0 = hoehearray[q - 1];
                temp1 = hoehearray[q];
                if (temp1 - temp0 < 0)
                {
                    hoehearray[q] = temp0;
                    hoehearray[q - 1] = temp1;
                }
            }
            neueHoehe = hoehearray[zeilenanzahl - 1];
            
        
        }
        public void SpaltenAufzeilen()
        {
            BreiteundHoehe();
            int buchstabenr = 0;
            for (int w = 0; w < zeilenzaehler; w++)
            {
                for (int a = 0; a < spaltenzaehler[w]; a++)
                {
                    Bitmap bmpBuchstabe = new Bitmap(neueBreite+1, neueHoehe+1);
                    for (int h = 0; h < neueHoehe+1; h++)
                    {
                        for (int b = 0; b < neueBreite+1; b++)
                        {
                            bmpBuchstabe.SetPixel(b, h, Color.White);
                        }
                    }
                    for (int q = 0; q < neueHoehe; q++)
                    {
                        for (int r = spaltenbreite[w, a, 0]; r <= spaltenbreite[w,a, 1]; r++)
                    {
                        if (zeileninhalt[w,q,r] == 1) bmpBuchstabe.SetPixel((r - spaltenbreite[w,a, 0]),q, Color.Black);
                        }
                    }
                    bmpBuchstabe.Save("C:\\Modellierungswoche07\\Text_zerlegen\\Text_zerlegen\\bin\\Debug\\Text_zerlegt\\" + (buchstabenr++) + ".bmp", System.Drawing.Imaging.ImageFormat.Bmp);
                }
            }
        }
#endregion
        private void butOpen_Click(object sender, EventArgs e)
        {
           zeilenanzahl=Convert.ToInt32(zeilenBox.Text);
            tbOutput.Text = "Beginne mit einlesen...\r\n";
            BildEinlesen();
            tbOutput.Text = tbOutput.Text + "Einlesen fertig!\r\nZeilen suchen...\r\n";
            ZeilenSuchen();
            tbOutput.Text = tbOutput.Text + "Zeilen erkannt!\r\nZeilen aufspalten...\r\n";
            ZeilenAufspalten();
            tbOutput.Text = tbOutput.Text + "Zeilen aufgespaltet!\r\nSpalten suchen...\r\n";
            SpaltenSuchen();
            tbOutput.Text = tbOutput.Text + "Spalten erkannt und zerlegt!\r\nText in Buchstaben zerlegen...\r\n";
            SpaltenAufzeilen();
            tbOutput.Text =tbOutput.Text+"Der Text wurde erfolgreich zerlegt!\r\n";
            MessageBox.Show("Buchtaben wurden erkannt und erfolgreich gespeichert");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Close();
        }

       
    }
}